Loading...
Searching...
No Matches
etl::private_optional::optional_impl< T, true > Class Template Reference

## Public Member Functions

ETL_CONSTEXPR14 T * | operator-> ()
| Pointer operator.
ETL_CONSTEXPR14 const T * | operator-> () const
| Pointer operator.
ETL_CONSTEXPR14 T & | operator* () ETL_LVALUE_REF_QUALIFIER
| Dereference operator.
ETL_CONSTEXPR14 const T & | operator* () const ETL_LVALUE_REF_QUALIFIER
| Dereference operator.
ETL_CONSTEXPR14 bool | has_value () const ETL_NOEXCEPT
ETL_CONSTEXPR14 ETL_EXPLICIT | operator bool () const
| Bool conversion operator.
ETL_CONSTEXPR14 T & | value () ETL_LVALUE_REF_QUALIFIER
| Get a reference to the value.
ETL_CONSTEXPR14 const T & | value () const ETL_LVALUE_REF_QUALIFIER
| Get a const reference to the value.
ETL_CONSTEXPR14 T | value_or (const T &default_value) const ETL_LVALUE_REF_QUALIFIER
| Gets the value or a default if not valid.
ETL_CONSTEXPR14 void | swap (optional_impl &other) ETL_NOEXCEPT
| Swaps this value with another.
ETL_CONSTEXPR14 void | reset () ETL_NOEXCEPT
| Reset back to invalid.
T & | emplace () ETL_NOEXCEPT
template<typename T1>
T & | emplace (const T1 &value1) ETL_NOEXCEPT
template<typename T1, typename T2>
T & | emplace (const T1 &value1, const T2 &value2) ETL_NOEXCEPT
template<typename T1, typename T2, typename T3>
T & | emplace (const T1 &value1, const T2 &value2, const T3 &value3) ETL_NOEXCEPT
template<typename T1, typename T2, typename T3, typename T4>
T & | emplace (const T1 &value1, const T2 &value2, const T3 &value3, const T4 &value4) ETL_NOEXCEPT

## Protected Types

typedef T | value_type
typedef optional_impl< T, true > | this_type

## Protected Member Functions

ETL_CONSTEXPR14 | optional_impl () ETL_NOEXCEPT
| Constructor.
ETL_CONSTEXPR14 | optional_impl (etl::nullopt_t) ETL_NOEXCEPT
| Constructor with nullopt.
ETL_CONSTEXPR14 | optional_impl (const optional_impl &other) ETL_NOEXCEPT
| Copy constructor.
ETL_CONSTEXPR14 optional_impl & | operator= (etl::nullopt_t) ETL_NOEXCEPT
| Assignment operator from nullopt.
ETL_CONSTEXPR14 optional_impl & | operator= (const optional_impl &other) ETL_NOEXCEPT
| Assignment operator from optional_impl.
ETL_CONSTEXPR14 optional_impl & | operator= (const T &value_) ETL_NOEXCEPT
| Assignment operator from value type.

## Member Function Documentation

## emplace() [1/5]

template<typename T>

T & etl::private_optional::optional_impl< T, true >::emplace | ( |  | ) |

inline

Emplaces a value. 0 parameters.

## emplace() [2/5]

template<typename T>
template<typename T1>

T & etl::private_optional::optional_impl< T, true >::emplace | ( | const T1 & | value1 | ) |

inline

Emplaces a value. 1 parameter.

## emplace() [3/5]

template<typename T>
template<typename T1, typename T2>

T & etl::private_optional::optional_impl< T, true >::emplace | ( | const T1 & | value1,
|  | const T2 & | value2 )

inline

Emplaces a value. 2 parameters.

## emplace() [4/5]

template<typename T>
template<typename T1, typename T2, typename T3>

T & etl::private_optional::optional_impl< T, true >::emplace | ( | const T1 & | value1,
|  | const T2 & | value2,
|  | const T3 & | value3 )

inline

Emplaces a value. 3 parameters.

## emplace() [5/5]

template<typename T>
template<typename T1, typename T2, typename T3, typename T4>

T & etl::private_optional::optional_impl< T, true >::emplace | ( | const T1 & | value1,
|  | const T2 & | value2,
|  | const T3 & | value3,
|  | const T4 & | value4 )

inline

Emplaces a value. 4 parameters.

The documentation for this class was generated from the following file:

- include/etl/optional.h